{% extends "page.html" %}
{% block left_nav %}
    <div id="left-nav" class="h2 ml-3 text-left position-absolute">
        <ul class="nav flex-column">
            {% if request.path not in ['/'] %}
                <li class="nav-item my-1">
                    <a href="{{ url_for('view.index') }}" id="btn-back" class="btn btn-outline-nav">&laquo;<span class="d-none d-lg-inline-block">&nbsp;Back</span></a>
                </li>
            {% elif g.admin %}
                <li class="nav-item bg-light my-1 mt-3">
                    <a href="{{ url_for('view.admin') }}" id="btn-admin" class="nav-link btn btn-outline-nav">Admin</a>
                </li>
            {% endif %}
        </ul>
    </div>
{% endblock left_nav %}
{% block clock %}
{% endblock clock %}
{% block content %}
    <section>
        <div class="container mx-auto">
            <div class="text-center mt-3">
                <h3 class="m-3">Visitors on site</h3>
                <table class="table table-sm table-bordered">
                    <thead class="thead-light">
                        <tr>
                            <th>Name</th>
                            <th>Host<br>and purpose</th>
                            <th>Contact</th>
                            <th>Car<br>Registration</th>
                            <th>Last seen time<br>and location</th>
                            <th>Card ID</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    {% for visitor_scan in signed_in %}
                        <tr>
                            <td>
                                {{ visitor_scan.visitor.name }}
                                <br>
                                {{ visitor_scan.visitor.organisation or "" }}
                            </td>
                            <td>
                                {% if visitor_scan.visitor.host %}
                                    {{ visitor_scan.visitor.host }}
                                    <br>
                                {% endif %}
                                {% if visitor_scan.visitor.location %}
                                    {{ visitor_scan.visitor.location }}
                                    <br>
                                {% endif %}
                                {{ visitor_scan.visitor.purpose or "" }}
                            </td>
                            <td>
                                {% if visitor_scan.visitor.telephone %}
                                    {{ visitor_scan.visitor.telephone }}
                                    <br>
                                {% endif %}
                                {% if visitor_scan.visitor.email %}
                                    <a href="mailto:{{ visitor_scan.visitor.email }}">{{ visitor_scan.visitor.email }}</a>
                                {% endif %}
                            </td>
                            <td>
                                {% if visitor_scan.visitor.car_registration %}
                                    {{ visitor_scan.visitor.car_registration }}
                                    <br>
                                {% endif %}
                                {{ visitor_scan.visitor.car_location or "" }}
                            </td>
                            <td>
                                <span data-timestamp="{{ visitor_scan.timestamp }}">
                                    {{ datetime.fromtimestamp(visitor_scan.timestamp).strftime('%a %H:%M') }}
                                </span>
                                <br>
                                {{ visitor_scan.building }}
                            </td>
                            <td>
                                {{ visitor_scan.visitor.card.id }}
                            </td>
                            <td class="text-nowrap">
                                <a class="btn btn-sign-out py-0 mb-1"
                                   href="{{ url_for('view.scan', reader='purple', visitor_id=visitor_scan.visitor.id) }}">Sign out
                                </a>
                                <a class="btn btn-primary py-0 mb-1"
                                   href="{{ url_for('view.index', flow='edit_visitor', visitor_id=visitor_scan.visitor.id) }}">View/Edit
                                </a>
                                <button class="btn btn-danger py-0 mb-1" type="button" data-toggle="collapse"
                                        data-target="#actions-panel-{{ visitor_scan.visitor.id }}">&hellip;</button>
                                <div class="collapse" id="actions-panel-{{ visitor_scan.visitor.id }}">
                                    <a class="btn btn-danger py-0 mb-1"
                                       href="{{ url_for('view.index', flow='archive', visitor_id=visitor_scan.visitor.id) }}">Archive
                                    </a>
                                    <a class="btn btn-danger py-0 mb-1"
                                       href="{{ url_for('view.index', flow='delete', visitor_id=visitor_scan.visitor.id) }}">Delete
                                    </a>
                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </table>
            </div>
            <div class="text-center mt-3">
                <h3 class="m-3">All visitors</h3>
                <table class="table table-sm table-bordered">
                    <thead class="thead-light">
                        <tr>
                            <th>Name</th>
                            <th>Host<br>and purpose</th>
                            <th>Contact</th>
                            <th>Car<br>Registration</th>
                            <th>Last active</th>
                            <th>Card ID</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    {% for visitor in visitors %}
                        <tr>
                            <td>
                                {{ visitor.name or "No name!" }}
                                <br>
                                {{ visitor.organisation or "" }}
                            </td>
                            <td>
                                {% if visitor.host %}
                                    {{ visitor.host }}
                                    <br>
                                {% endif %}
                                {% if visitor.location %}
                                    {{ visitor.location }}
                                    <br>
                                {% endif %}
                                {{ visitor.purpose or "" }}
                            </td>
                            <td>
                                {% if visitor.telephone %}
                                    {{ visitor.telephone }}
                                    <br>
                                {% endif %}
                                {% if visitor.email %}
                                    <a href="mailto:{{ visitor.email }}">{{ visitor.email }}</a>
                                {% endif %}
                            </td>
                            <td>
                                {% if visitor.car_registration %}
                                    {{ visitor.car_registration }}
                                    <br>
                                {% endif %}
                                {{ visitor.car_location or "" }}
                            </td>
                            <td>
                                {% if visitor.last_active %}
                                    <span data-timestamp="{{ visitor.last_active }}">
                                        {{ datetime.fromtimestamp(visitor.last_active).strftime('%c') }}
                                    </span>
                                {% endif %}
                            </td>
                            <td>
                                {{ visitor.card.id }}
                            </td>
                            <td class="text-nowrap">
                                {% if visitor.signed_in() %}
                                    <a class="btn btn-sign-out py-0 mb-1"
                                       href="{{ url_for('view.scan', reader='purple', visitor_id=visitor.id) }}">Sign out
                                    </a>
                                {% else %}
                                    <a class="btn btn-sign-in py-0 mb-1"
                                       href="{{ url_for('view.scan', reader='yellow', visitor_id=visitor.id) }}">Sign in
                                    </a>
                                {% endif %}
                                <a class="btn btn-primary py-0 mb-1"
                                   href="{{ url_for('view.index', flow='edit_visitor', visitor_id=visitor.id) }}">View/Edit
                                </a>
                                <button class="btn btn-danger py-0 mb-1" type="button" data-toggle="collapse"
                                        data-target="#actions-panel-{{ visitor.id }}">&hellip;</button>
                                <div class="collapse" id="actions-panel-{{ visitor.id }}">
                                    <a class="btn btn-danger py-0 mb-1"
                                       href="{{ url_for('view.index', flow='archive', visitor_id=visitor.id) }}">Archive</a>
                                    <a class="btn btn-danger py-0 mb-1"
                                       href="{{ url_for('view.index', flow='delete', visitor_id=visitor.id) }}">Delete</a>
                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </table>
                <form action="{{ url_for("view.index") }}" method="get" id="assign-by-card-id">
                    <div class="form-row">
                        <input type="hidden" name="flow" value="assign_visitor">
                        <label class="col-form-label form-control-sm ml-auto sr-only" for="assign-card-id">Card ID</label>
                        <div class="col-1 ml-auto">
                            <input type="text" class="form-control form-control-sm" id="assign-card-id" name="card_id"
                                   placeholder="Card ID">
                        </div>
                        <div class="col-auto">
                            <button type="submit" class="btn btn-primary py-0">New Visitor</button>
                        </div>
                    </div>
                </form>
            </div>
            <div class="text-center mt-3">
                <h3 class="m-3">Visitors Archive</h3>
                <table class="table table-sm table-bordered">
                    <thead class="thead-light">
                        <tr>
                            <th>Name</th>
                            <th>Host<br>and purpose</th>
                            <th>Contact</th>
                            <th>Car<br>Registration</th>
                            <th>Last active</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    {% for visitor in archive %}
                        <tr>
                            <td>
                                {{ visitor.name or "No Name!" }}
                                <br>
                                {{ visitor.organisation or "" }}
                            </td>
                            <td>
                                {% if visitor.host %}
                                    {{ visitor.host }}
                                    <br>
                                {% endif %}
                                {% if visitor.location %}
                                    {{ visitor.location }}
                                    <br>
                                {% endif %}
                                {{ visitor.purpose or "" }}
                            </td>
                            <td>
                                {% if visitor.telephone %}
                                    {{ visitor.telephone }}
                                    <br>
                                {% endif %}
                                {{ visitor.email or "" }}
                            </td>
                            <td>
                                {% if visitor.car_registration %}
                                    {{ visitor.car_registration }}
                                    <br>
                                {% endif %}
                                {{ visitor.car_location or "" }}
                            </td>
                            <td>
                                {% if visitor.last_active %}
                                    <span data-timestamp="{{ visitor.last_active }}">
                                        {{ datetime.fromtimestamp(visitor.last_active).strftime('%c') }}
                                    </span>
                                {% endif %}
                            </td>
                            <td class="text-nowrap">
                                <a class="btn btn-primary py-0 mb-1"
                                   href="{{ url_for('view.index', flow='view_visitor', visitor_id=visitor.id) }}">View
                                </a>
                                <button class="btn btn-danger py-0 mb-1" type="button" data-toggle="collapse"
                                        data-target="#archive-actions-{{ visitor.id }}">&hellip;</button>
                                <div class="collapse" id="archive-actions-{{ visitor.id }}">
                                    <form class="form-inline d-block my-1" action="{{ url_for("view.index") }}"
                                          method="get" id="reactivate-{{ visitor.id }}-by-card">
                                        <input type="hidden" name="flow" value="reactivate_visitor">
                                        <input type="hidden" name="visitor_id" value="{{ visitor.id }}">
                                        <label class="col-form-label form-control-sm sr-only" for="reactivate-{{ visitor.id }}">Card ID
                                        </label>
                                        <input type="text" class="form-control form-control-sm" id="reactivate-{{ visitor.id }}"
                                               name="card_id" placeholder="Card ID" size="6">
                                        <button type="submit" class="btn btn-secondary py-0">Reactivate</button>
                                    </form>
                                    <a class="btn btn-danger py-0 mb-1"
                                       href="{{ url_for('view.index', flow='delete', visitor_id=visitor.id) }}">Delete
                                    </a>

                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </table>
            </div>
            <div class="text-center mt-3">
                <h3 class="m-3">Administrators</h3>
                <table class="table table-sm table-bordered">
                    <thead class="thead-light">
                        <tr>
                            <th>Name</th>
                            <th>CRSid</th>
                            <th>Contact</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    {% for admin in admins %}
                        <tr>
                            <td>
                                {{ admin.name }}
                            </td>
                            <td>
                                {{ admin.crsid or "" }}
                            </td>
                            <td>
                                {% if admin.crsid %}{{ admin.crsid }}@cam.ac.uk<br>{% endif %}
                                {{ admin.telephone or "" }}
                            </td>
                            <td class="text-nowrap">
                                <a class="btn btn-secondary py-0 mb-1"
                                   href="{{ url_for("view.index", flow="edit_administrator", admin_id=admin.id) }}">Edit
                                </a>
                                <button class="btn btn-danger py-0 mb-1" type="button" data-toggle="collapse"
                                        data-target="#admin-actions-{{ admin.id }}">&hellip;</button>
                                <div class="collapse" id="admin-actions-{{ admin.id }}">
                                    <a class="btn btn-danger py-0"
                                       href="{{ url_for('view.index', flow="delete", admin_id=admin.id) }}">Delete
                                    </a>
                                </div>
                            </td>
                        </tr>
                    {% endfor %}
                </table>
            </div>
            {% if g.sign_in_available %}
                <a
                    class="btn btn-lg btn-outline-secondary bg-light bottom-fix centre-fix switch-mode"
                    id="btn-switch-to-sign-in"
                    data-target-mode="sign-in"
                    href="{{ url_for('view.index') }}">
                    <span class="h4">⇄ Switch to {{ configuration.SITE_TITLE }}</span>
                </a>
            {% endif %}
            {% if admin %}
                <div class="bottom-fix right-fix">
                    <a
                        href="https://raven.cam.ac.uk/"
                        target="_blank"
                        id="btn-sign-out"
                        title="Signed in with Raven; close browser to logout"
                        class="btn btn-sign-out btn-lg text-center">
                            Signed in as {{ admin.name }} ({{ admin.crsid }})
                    </a>
                </div>
            {% endif %}
        </div>
    </section>
{% endblock content %}